#include "StdAfx.h"
#include "Matrix.h"
#include <malloc.h>

Matrix::Matrix(int size)
{
	this->size=size;
	data=(double **) malloc(sizeof(double*)*size);
	for (int i=0;i<size;i++)
		data[i]=(double *) malloc(sizeof(double)*(size+1));
}

void Matrix::set(int x, int y, double value) {
	data[y][x]=value;
}

void Matrix::solve() {
	for (int i=0;i<size;i++) {
		int max=i;
		double maxValue=data[i][i];
		for (int j=i+1;j<size;j++) {
			if (maxValue<data[j][i]) {
				maxValue=data[j][i];
				max=j;
			}
		}
		for (int j=0;j<size+1;j++) {
			double x=data[max][j];
			data[max][j]=data[i][j];
			data[i][j]=x;
		}
		double x=data[i][i];
		for (int j=0;j<size+1;j++) {
			data[i][j]/=x;
		}
		for (int j=0/*i+1*/;j<size;j++) {
			if (j!=i) {
				double x=data[j][i];
				for (int k=i;k<size+1;k++) {			
					if (j!=i)
						data[j][k]-=x*data[i][k];
			
				}
			}
		}
	}
}

double Matrix::get(int i) {
	return data[i][size];
}

void Matrix::print() {
	for (int i=0;i<size;i++) {
		for (int j=0;j<size+1;j++) {
			printf("%lf ",data[i][j]);
		}
		printf("\n");
	}
	printf("\n\n\n\n\n");
}

Matrix::~Matrix(void)
{
	for (int i=0;i<size;i++)
		free(data[i]);
	free(data);
}
