// X36ANM.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <math.h>

#include "Add.h"
#include "Const.h"
#include "Derive.h"
#include "Div.h"
#include "Exp.h"
#include "Mul.h"
#include "Oper.h"
#include "Operation.h"
#include "Sqrt.h"
#include "Sub.h"
#include "Sum.h"

#include "Data.h"

#include "Matrix.h"

Oper **oper=new (Oper(*[5]));
Oper **var=new (Oper(*[2]));

Operation **f=new (Operation(*[3]));

Matrix *m=new Matrix(5);
Data *data;

double go(Operation *s) {
	for (int j=0;j<5;j++) {
		Operation *fd=new Derive(s,oper[j]);
		double v=0.;
		for (int k=0;k<5;k++) {
			Sum *sum=new Sum(new Derive(fd,oper[k]),var[0],var[1]);				
			double f=sum->getResult();
			m->set(k,j,f);
			v+=f*oper[k]->getResult();
		}
		m->set(5,j,v-(new Sum(fd,var[0],var[1]))->getResult());
	}
	m->solve();
	return (new Sum(s,var[0],var[1]))->getResult();
}

double getRel() {
	double rel=0.;
	for (int i=0;i<21;i++) 
		for (int j=0;j<21;j++) {
			var[0]->setPosition(i);
			var[1]->setPosition(j);
			double x=abs(data->getResult()-f[0]->getResult());
			double r=abs(abs(x/data->getResult())-1);
			if (r>rel) {
				rel=r;
			}
		}
	return rel;
}

double getAbs() {
	double delta=0.;
	for (int i=0;i<21;i++) 
		for (int j=0;j<21;j++) {
			var[0]->setPosition(i);
			var[1]->setPosition(j);
			double x=abs(data->getResult()-f[0]->getResult());
			if (x>delta) {
				delta=x;
			}
		}
	return delta;
}

void printRelAbs() {
	printf("SIGMA=%lf, rel=%lf\n",getAbs(),getRel());
}

double go(int idF, double a, double b, double c, double d, double e, double step, double min) {
	double best[5];
	printf("FUNKCE %d\n==========\n",idF+1);
	//for (int j=0;j<5;j++) oper[j]->setValue(0.1);
	oper[0]->setValue(a);
	oper[1]->setValue(b);
	oper[2]->setValue(c);
	oper[3]->setValue(d);
	oper[4]->setValue(e);
	Oper::DELTA=step;
	for (int i=0;i<5;i++) best[i]=oper[i]->getResult();
	Operation *s=new Sqrt(
		new Sub(f[idF],data)
	);
	double max=(new Sum(s,var[0],var[1]))->getResult();
	printf("%lf > ",max);
	int count=0;
	while (true) {
		for (int i=0;i<5;i++) oper[i]->setValue(best[i]);
		go(s);
		for (int i=0;i<5;i++) oper[i]->setValue(m->get(i));
		if (max>(new Sum(s,var[0],var[1]))->getResult()) {
			max=(new Sum(s,var[0],var[1]))->getResult();
			printf("%lf > ",max);
			for (int i=0;i<5;i++) {
				best[i]=m->get(i);
			}	
			count=0;
			if (max<min*min) { 
				if (getAbs()<min) {
					break;
				}
			}
		} else {
			Oper::DELTA*=.1;
			if (count>25) break;
			count++;			
		}		
	}
	printf("STOP\n\nReseni:");

	printf("[");
	for (int i=0;i<5;i++) {
		if (i>0) printf(",");
		printf("%lf",best[i]);
		oper[i]->setValue(best[i]);
	}
	printf("]\n");

	double out=(new Sum(s,var[0],var[1]))->getResult();
	printf("S=%lf\n",out);

	for (int i=0;i<5;i++)
		oper[i]->setValue(best[i]);
	printRelAbs();

	return out;
}

int _tmain(int argc, _TCHAR* argv[])
{
	for (int i=0;i<5;i++) oper[i]=new Oper();
	for (int i=0;i<2;i++) var[i]=new Oper();
	f[0]= //\!(a*x1 + b*x2*x1 + Exp[(c - x1)^2]/(1 + x1*x2*d + x1^2*e))
		new Add(
			new Add(
				new Mul(oper[0], var[0]),
				new Mul(
					new Mul(var[0], var[1]),
					oper[1]
				)
			),
			new Div(
				new Exp(
					new Sqrt(
						new Sub(oper[2],var[0])
					)
				),
				new Add(
					new Add(
						new Const(1.),
						new Mul(
							new Mul(var[0],var[1]),
							oper[3]
						)
					),
					new Mul(
						new Sqrt(var[0]),
						oper[4]
					)
				)
			)
		);


	f[1]= //(a*x1 + b*x2*x1 + Exp[(c - x2)^2]/(1 + x1*x2*d + x2^2*e)
		new Add(
			new Add(
				new Mul(oper[0], var[0]),
				new Mul(
					new Mul(var[0], var[1]),
					oper[1]
				)
			),
			new Div(
				new Exp(
					new Sqrt(
						new Sub(oper[2],var[1])
					)
				),
				new Add(
					new Add(
						new Const(1.),
						new Mul(
							new Mul(var[0],var[1]),
							oper[3]
						)
					),
					new Mul(
						new Sqrt(var[1]),
						oper[4]
					)
				)
			)
		);


	f[2]= //(a*x1 + b*x2*x1 + Exp[(c - x1)^2]/(e + x1*x2*d))
		new Add(
			new Add(
				new Mul(oper[0], var[0]),
				new Mul(
					new Mul(var[0], var[1]),
					oper[1]
				)
			),
			new Div(
				new Exp(
					new Sqrt(
						new Sub(oper[2],var[0])
					)
				),
				new Add(
					oper[4],
					new Mul(
						new Mul(var[0],var[1]),
						oper[3]
					)
				)
			)
		);
	data=new Data(var[0],var[1]);
	double sResult[3];

	double min=0.001;

	sResult[0]=go(0,-1,1,1,1,-1,1./1024.,min);
	sResult[1]=go(1,-1,1,1,1,-1,1./1024.,min);
	sResult[2]=go(2,1,1,1,1,1,.2,min);

	for (int i=0;i<5;i++) delete oper[i];
	delete oper;
	for (int i=0;i<2;i++) delete var[i];
	delete var;
	for (int i=0;i<3;i++) delete f[i];
	delete f;
	delete m;
	delete data;
	
	char c;
	scanf("%c",&c);
	return 0;
}

